/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    :   adslAtucIntervalTable_access.h
 * Author       :   Subramani
 * Date         :   17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      :   Amazon
 * Block        :   ADSL-MIBs
 *
 * ===========================================================================
 * Contents:    This file contains :
 *              1)  Include files
 *              2)  User defined data types
 *              3)  Function proto-types for adslAtucIntervalTable_access
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */



/* ===========================================================================
 * Revision History:
 * Subramani: Return type for get_adslAtucIntervalValidData changed from long
 *   to int
 * $Log$
 * ===========================================================================
*/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */
//#include <adslMIBincl.h>

#ifndef ADSLATUCINTERVALTABLE_ACCESS_H
#define ADSLATUCINTERVALTABLE_ACCESS_H

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
*/
#include <adslMIB/adslTable_access.h>


/*
 * ===========================================================================
 *                        USER-DEFINED DATA TYPES
 * ===========================================================================
*/

/** User-defined data structure for accessing adslAtucIntervalTable **/

#ifdef STUB_IOCTL
#define PerfIntervalCount u_int32

typedef struct adslAtucIntvlInfo {
    int ifIndex;
    int IntervalNumber;
    PerfIntervalCount intervalLOF;
    PerfIntervalCount intervalLOS;
    PerfIntervalCount intervalES;
    PerfIntervalCount intervalInits;
    int intervalValidData;
    u_char flags;
} adslAtucIntvlInfo;
#endif
/*
 * ===========================================================================
 *                           FUNCTION PROTOTYPES
 * ===========================================================================
*/

/**User-defined data access functions for data in table adslAtucIntervalTable */
/** row level accessors */
Netsnmp_First_Data_Point adslAtucIntervalTable_get_first_data_point;
Netsnmp_Next_Data_Point adslAtucIntervalTable_get_next_data_point;


/** column accessors */
#if defined(HAVE_OPTIMIZED_CODE)
u_int32      *
get_adslAtucIntervalData(void *data_context, size_t * ret_len, 
		unsigned int var);
#else
u_int32    *get_adslAtucIntervalLofs(void *data_context, size_t * ret_len);
u_int32    *get_adslAtucIntervalLoss(void *data_context, size_t * ret_len);
u_int32    *get_adslAtucIntervalESs(void *data_context, size_t * ret_len);
u_int32    *get_adslAtucIntervalInits(void *data_context, size_t * ret_len);
#endif

int       *get_adslAtucIntervalValidData(void *data_context, size_t * ret_len);

#ifndef ENABLE_DRIVER_CALL
int get_adslAtucIntervalTable(int Fd2,int GET_adsl_ATUC_INTVL_INFO2,
                void *adslAtucInvtlTable);
#endif

#endif                          /* ADSLATUCINTERVALTABLE_ACCESS_H */
