/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    :   adslAtucPerfDataTable_access.h
 * Author       :   Subramani
 * Date         :   17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      :   Amazon
 * Block        :   ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains :
 *              1)  Include files
 *              2)  User defined data types
 *              3)  Function proto-types for adslAtucPerfDataTable_access
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */



/* ===========================================================================
 * Revision History:
 * Subramani:1)Return type of get_adslAtucPerfValidIntervals ,
 * get_adslAtucPerfInvalidIntervals and get_adslAtucPerfPrev1DayMoniSecs
 * changed from long to int
 * $Log$
 * ===========================================================================
s*/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */
//#include <adslMIBincl.h>


#ifndef ADSLATUCPERFDATATABLE_ACCESS_H
#define ADSLATUCPERFDATATABLE_ACCESS_H

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
*/
#include <adslMIB/adslTable_access.h>

/*
 * ===========================================================================
 *                        USER-DEFINED DATA TYPES
 * ===========================================================================
*/

#ifdef STUB_IOCTL
/** User-defined data structure for accessing adslAtucPerfDataTable **/

#define AdslPerfTimeElapsed u_int32
#define PerfCurrentCount u_int32
#define AdslPerfCurrDayCount u_int32
#define AdslPerfPrevDayCount u_int32

typedef struct atucPerfDataEntry
{
   int          ifIndex;
   u_int32          adslAtucPerfLofs;
   u_int32          adslAtucPerfLoss;
   u_int32          adslAtucPerfESs;
   u_int32          adslAtucPerfInits;
   int              adslAtucPerfValidIntervals;
   int              adslAtucPerfInvalidIntervals;
   AdslPerfTimeElapsed  adslAtucPerfCurr15MinTimeElapsed;
   PerfCurrentCount     adslAtucPerfCurr15MinLofs;
   PerfCurrentCount     adslAtucPerfCurr15MinLoss;
   PerfCurrentCount     adslAtucPerfCurr15MinESs;
   PerfCurrentCount     adslAtucPerfCurr15MinInits;
   AdslPerfTimeElapsed  adslAtucPerfCurr1DayTimeElapsed;
   AdslPerfCurrDayCount adslAtucPerfCurr1DayLofs;
   AdslPerfCurrDayCount adslAtucPerfCurr1DayLoss;
   AdslPerfCurrDayCount adslAtucPerfCurr1DayESs;
   AdslPerfCurrDayCount adslAtucPerfCurr1DayInits;
   int              adslAtucPerfPrev1DayMoniSecs;
   AdslPerfPrevDayCount adslAtucPerfPrev1DayLofs;
   AdslPerfPrevDayCount adslAtucPerfPrev1DayLoss;
   AdslPerfPrevDayCount adslAtucPerfPrev1DayESs;
   AdslPerfPrevDayCount adslAtucPerfPrev1DayInits;
   u_int32          flags;
} atucPerfDataEntry;
#endif

/*
 * ===========================================================================
 *                           FUNCTION PROTOTYPES
 * ===========================================================================
*/

/** User-defined data access functions for data in table
    adslAtucPerfDataTable */
/** row level accessors */
Netsnmp_First_Data_Point adslAtucPerfDataTable_get_first_data_point;
Netsnmp_Next_Data_Point adslAtucPerfDataTable_get_next_data_point;


/** column accessors */
#if defined(HAVE_OPTIMIZED_CODE)
u_int32  *
get_adslAtucPerfDataLoss(void *data_context, size_t * ret_len,
			unsigned int var);


int *
get_adslAtucPerfIntervalData(void *data_context, size_t * ret_len,
			unsigned int var);

u_int32  *
get_adslAtucPerfDataStats(void *data_context, size_t * ret_len,
			unsigned int var);
#else
u_int32  *get_adslAtucPerfLofs(void *data_context, size_t * ret_len);
u_int32  *get_adslAtucPerfLoss(void *data_context, size_t * ret_len);
u_int32  *get_adslAtucPerfESs(void *data_context, size_t * ret_len);
u_int32  *get_adslAtucPerfInits(void *data_context, size_t * ret_len);
int   *get_adslAtucPerfValidIntervals(void *data_context, size_t * ret_len);
int   *get_adslAtucPerfInvalidIntervals(void *data_context, size_t * ret_len);
u_int32  *get_adslAtucPerfCurr15MinTimeElapsed(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAtucPerfCurr15MinLofs(void *data_context, size_t * ret_len);
u_int32  *get_adslAtucPerfCurr15MinLoss(void *data_context, size_t * ret_len);
u_int32  *get_adslAtucPerfCurr15MinESs(void *data_context, size_t * ret_len);
u_int32  *get_adslAtucPerfCurr15MinInits(void *data_context, size_t * ret_len);
u_int32  *get_adslAtucPerfCurr1DayTimeElapsed(void *data_context,
            size_t *ret_len);
u_int32  *get_adslAtucPerfCurr1DayLofs(void *data_context, size_t * ret_len);
u_int32  *get_adslAtucPerfCurr1DayLoss(void *data_context, size_t * ret_len);
u_int32  *get_adslAtucPerfCurr1DayESs(void *data_context, size_t * ret_len);
u_int32  *get_adslAtucPerfCurr1DayInits(void *data_context, size_t * ret_len);
int     *get_adslAtucPerfPrev1DayMoniSecs(void *data_context,size_t * ret_len);
u_int32  *get_adslAtucPerfPrev1DayLofs(void *data_context, size_t * ret_len);
u_int32  *get_adslAtucPerfPrev1DayLoss(void *data_context, size_t * ret_len);
u_int32  *get_adslAtucPerfPrev1DayESs(void *data_context,  size_t * ret_len);
u_int32  *get_adslAtucPerfPrev1DayInits(void *data_context, size_t * ret_len);
#endif


#ifndef ENABLE_DRIVER_CALL
int get_adslAtucPerfDataTable(int Fd2,int GET_adsl_ATUC_PERF_DATA2,void *atucPerfDataValue);
#endif

#endif                          /* ADSLATUCPERFDATATABLE_ACCESS_H */
