/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    :   adslAtucPhysTable_access.h
 * Author       :   Subramani
 * Date         :   17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      :   Amazon
 * Block        :   ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains :
 *              1)  Include files
 *              2)  User defined data types
 *              3)  Function proto-types for adslAtucPhysTable_access
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */



/* ===========================================================================
 * Revision History:
 * Subramani:  24-Jun04 Changed the return types for get_adslAtucCurrOutputPwr
 * and  get_adslAtucCurrAttainableRate
 * $Log$
 * ===========================================================================
 */

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */
//#include <adslMIBincl.h>

#ifndef ADSLATUCPHYSTABLE_ACCESS_H
#define ADSLATUCPHYSTABLE_ACCESS_H

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
*/

#include <adslMIB/adslTable_access.h>

/*
 * ===========================================================================
 *                        USER-DEFINED DATA TYPES
 * ===========================================================================
*/

/** User-defined data structure for accessing AtucPhysTable **/

#ifdef STUB_IOCTL
typedef struct adslAtucPhysEntry {
    int ifIndex;
    char serial_no[32];
    char vendor_id[16];
    char version_no[16];
    u_int32 status;
    int outputPwr;
    u_int32 attainableRate;
    u_char flags;
} adslAtucPhysEntry;
#endif

/*
 * ===========================================================================
 *                           FUNCTION PROTOTYPES
 * ===========================================================================
*/

/** User-defined data access functions for data in table adslAtucPhysTable */
/** row level accessors */

Netsnmp_First_Data_Point adslAtucPhysTable_get_first_data_point;
Netsnmp_Next_Data_Point adslAtucPhysTable_get_next_data_point;


/** column accessors */
#if defined(HAVE_OPTIMIZED_CODE)
char  *
get_adslAtucInvData(void *data_context, size_t * ret_len,
			unsigned int var);

#else
char       *get_adslAtucInvSerialNumber(void *data_context, size_t * ret_len);
char       *get_adslAtucInvVendorID(void *data_context, size_t * ret_len);
char       *get_adslAtucInvVersionNumber(void *data_context, size_t * ret_len);
#endif

u_int32        *get_adslAtucCurrStatus(void *data_context, size_t * ret_len);
int           *get_adslAtucCurrOutputPwr(void *data_context, size_t * ret_len);
u_int32   *get_adslAtucCurrAttainableRate(void *data_context, size_t * ret_len);

#ifndef ENABLE_DRIVER_CALL
int get_adslAtucPhysTable1(int Fd2, int GET_adsl_ATUC_PHY2,
                        void *adslAtucPhysTable);
#endif

#endif                          /* ADSLATUCPHYSTABLE_ACCESS_H */
