/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    : adslAturIntervalTable_access.h
 * Author       : Subbi
 * Date         : 17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      : Amazon
 * Block        : ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains:
 *                 1) User-defined data structure for accessing
 *                    adslAturIntervalTable
 *                 2) User-defined data access functions for data in table
 *                    adslAturIntervalTable
 *                 3) Column accessors functions
 *
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */

/* ===========================================================================
 * Revision History:
 * Subramani: Changed the return types of get_adslAturIntervalValidData
 * $Log$
 * ===========================================================================
 */

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */

#ifndef ADSLATURINTERVALTABLE_ACCESS_H
#define ADSLATURINTERVALTABLE_ACCESS_H

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
 */
#include <adslMIB/adslTable_access.h>

/*
 * ===========================================================================
 *                           USER-DEFINED DATA TYPES
 * ===========================================================================
 */
#ifdef STUB_IOCTL
/** User-defined data structure for accessing adslAturIntervalTable **/
#define PerfIntervalCount u_int32

typedef struct adslAturIntvlInfo {
    int ifIndex;
    int IntervalNumber;
    PerfIntervalCount intervalLOF;
    PerfIntervalCount intervalLOS;
    PerfIntervalCount intervalLPR;
    PerfIntervalCount intervalES;
    int intervalValidData;
    u_char flags;
} adslAturIntvlInfo;
#endif

/*
 * ===========================================================================
 *                           FUNCTION PROTOTYPES
 * ===========================================================================
 */

/* User-defined data access functions for data in table adslAturIntervalTable */
/** row level accessors */
Netsnmp_First_Data_Point adslAturIntervalTable_get_first_data_point;
Netsnmp_Next_Data_Point adslAturIntervalTable_get_next_data_point;

/** column accessors */
#if defined(HAVE_OPTIMIZED_CODE)
u_int32      *
get_adslAturIntervalData(void *data_context, size_t * ret_len, 
		unsigned int var);
#else
u_int32 *get_adslAturIntervalLofs(void *data_context, size_t * ret_len);
u_int32 *get_adslAturIntervalLoss(void *data_context, size_t * ret_len);
u_int32 *get_adslAturIntervalLprs(void *data_context, size_t * ret_len);
u_int32 *get_adslAturIntervalESs(void *data_context, size_t * ret_len);
#endif
int    *get_adslAturIntervalValidData(void *data_context, size_t * ret_len);

#ifndef ENABLE_DRIVER_CALL
int get_adslAturIntervalTable(int Fd2,int GET_adsl_ATUR_INTVL_INFO2,
            void *adslAturInvtlTable);
#endif

#endif                          /* ADSLATURINTERVALTABLE_ACCESS_H */
