/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    : adslTable_access.h
 * Author       : Subbi
 * Date         : 17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      : Amazon
 * Block        : ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains:
 *                 1) User-defined constants which can be accessed globally
 *                 2) Macro definitions for Setting & Testing the flags
 *                 3) Data access functions
 *
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */

/* ===========================================================================
 * Revision History:
 *
 * $Log$
 * ===========================================================================
 */

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */
/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
*/
#include <fcntl.h>

#ifndef STUB_IOCTL
#include <asm/amazon/amazon_mei_app_ioctl.h>
#define ENABLE_DRIVER_CALL
#define ADSL_DEV_PATH "/dev/amazon/mei"
#endif
/*
 * ===========================================================================
 *                          DEFINITIONS
 * ===========================================================================
 */
#define  u_int32 unsigned int
#define  u_int16 unsigned short
#define AMAZON_MEM_LEAK_FIX
#define ALARM_PROF_NAME_STR_LENGTH 11

/* Interface Type */
#define IFTYPE_ADSL 94
#define IFTYPE_ADSL_INTERLEAVE 124
#define IFTYPE_ADSL_FAST 125
#define IFTYPE_ADSL_FAST_INTERLEAVE 5678

#ifdef STUB_IOCTL
//****** Macro Definitions - FLAG Setting & Testing
// -- This macro sets the flags with the flag_val. Here flags is passed as a
// pointer
#define SET_FLAG(flags, flag_val)   ((*(flags)) = ((*(flags)) | (flag_val)))

//-- This macro verifies whether test_flag has been set in flags.
//   Here flags is passed as a pointer
#define IS_FLAG_SET(flags, test_flag) (((*(flags) & (test_flag)) == \
                                        (test_flag))? test_flag : 0)

/*Ex: Say we want to get the value of adslAtucInvSerialNumber from the
adslAtucPhysTable.For this we first set the ATUC_PHY_SER_NUM_FLAG, using the
macro SET_FLAG(flags, ATUC_PHY_SER_NUM_FLAG).Once the driver API is called it
checks for which variable has been requested by invoking the macro IS_FLAG_SET(
flags, ATUC_PHY_SER_NUM_FLAG) and then sending the response for that variable!
If the requested variable cannot be retrieved or modified, then the flag will be
reset by the driver. On receiving the response from the driver at the user
application NET-SNMP), if the requested flag is reset by the driver then we
raise an SNMP_GENERROR else we pass the returned value to the application.
*/

// -- This macro resets the specified flag_bit in the flags.
//    Here flags is passed as a pointer
#define CLR_FLAG(flags, flag_bit)   ((*flags) = ((*(flags)) & (~(flag_bit))))
#endif


//Global Definitions
/**** File Pointer to the device ******/
int Fd;


int *position;
int *Data_Context;
char *Alarm_Data_Context;


/*
 * ===========================================================================
 *                           FUNCTION PROTOTYPES
 * ===========================================================================
 */
// functions prototype

Netsnmp_First_Data_Point adslTable_get_first_data_point;
Netsnmp_Next_Data_Point adslTable_get_next_data_point;

Netsnmp_First_Data_Point adslAlarmTable_get_first_data_point;
Netsnmp_First_Data_Point adslAlarmTable_get_next_data_point;

int adsl_ioctl(int fd, int cmd, void *structptr);

int dev_open(const char *pathname, int flags);

int dev_close(int fd);

static int GetType(int index);

static int GetNoInterfaces();

