/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-LAN-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxStaticConfTable_access.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "ifxStaticConfTable_access.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
static char                 cTag[MAX_TAG_LEN];
static char                 cRetVal[MAX_DATA_LEN];
static unsigned int         nEntryNum = 0;

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
*/
void *
ifxGetLanStaticCount()
{
    /* printf("**** ifxGetLanStaticCount ****\n"); */
    memset (&cRetVal, 0x00, MAX_DATA_LEN);
    memset (&xMibMsg, 0x00, sizeof(IFX_MIB_MSG_S));

	if (ifx_GetCfgData(FILE_RC_CONF, "wan_static_alias", "aliasIPCount",
	                   cRetVal) != 1)
	{
        DEBUGMSGTL(("snmpd", "unable get aliasIPCount\n"));
	}
    nEntryNum = atoi(cRetVal);

    if (nEntryNum > 0)
    {
        xMibMsg.nType = IFX_MIB_WAN_STATIC;
        xMibMsg.nCount = nEntryNum;
        xMibMsg.nPSize = sizeof(STATICCFG_S *);
        xMibMsg.nSize = sizeof(STATICCFG_S);

        ifx_MIB_Dalloc();
	}
}

netsnmp_variable_list *
ifxStaticConfTable_set_indexes(STATICCFG_S *datainfo,
                               netsnmp_variable_list *put_index_data)
{
    /* printf("**** ifxStaticConfTable_set_indexes ****\n"); */
    netsnmp_variable_list   *vptr;

    /* staticIndex */
    vptr = put_index_data;
    snmp_set_var_value(vptr, (u_char *) &datainfo->index ,
                       sizeof(datainfo->index) );

    return put_index_data;
}

STATICCFG_S  **
ifxStaticConfTable_get_data(void)
{
    int              i = 0;
    char             sCommand[MAX_DATA_LEN];
	char             *ip = NULL;

    ifxGetLanStaticCount();

    for ( i = 0; i < nEntryNum; i++)
    {
	    pstWanStaticCfg[i]->index = i;

        memset (&cRetVal, 0x00, MAX_DATA_LEN);
        memset (&cTag, 0x00, MAX_TAG_LEN);
        memset (&sCommand, 0x00, MAX_DATA_LEN);
        sprintf (cTag, "aliasIP%d", i);
        if ( ifx_GetCfgData(FILE_RC_CONF, "wan_static_alias", cTag,
                            cRetVal) != 1)
		{
			DEBUGMSGTL(("snmpd", "unable get WAN Static aliasIP\n"));
		}

        ip = strtok(cRetVal, " ");
        strcpy (pstWanStaticCfg[i]->cIpAddr, ip);
        ip = strtok( NULL, " ");
        ip = strtok( NULL, " ");
    	strcpy (pstWanStaticCfg[i]->cNetmask, ip);
        ip = strtok( NULL, " ");
        ip = strtok( NULL, " ");
        strcpy (pstWanStaticCfg[i]->cGateway, ip);
    }
}

/** returns the first data point within the ifxStaticConfTable table data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
ifxStaticConfTable_get_first_data_point(void **my_loop_context,
                                        void **my_data_context,
                                        netsnmp_variable_list *
                                        put_index_data,
                                        netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxStaticConfTable_get_first_data_point ****\n"); */
    int     *position;

    /* we could do this with a file-static variable, but for learning
       purposes we'll use memory allocation to demonstrate simplistic
       freeing of a loop_context */
    position = (int *)malloc(sizeof(int));
    if (!position)
        return NULL;

    ifxStaticConfTable_get_data();

    if (!pstWanStaticCfg)
    {
        snmp_log(LOG_ERR, "ifxStaticConfTable: None of row for this table.\n");
        free(position);
        return NULL;
    }

    /* We use the positinonal count as our loop context */
    *position = 0;
    *my_loop_context = position;

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = pstWanStaticCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxStaticConfTable_set_indexes(pstWanStaticCfg[*position],
                                          put_index_data);
}

/** functionally the same as ifxStaticConfTable_get_first_data_point, but
   my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
ifxStaticConfTable_get_next_data_point(void **my_loop_context,
                                       void **my_data_context,
                                       netsnmp_variable_list *
                                       put_index_data,
                                       netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxStaticConfTable_get_next_data_point ****\n"); */
    int *position = (int *) *my_loop_context;

    /* make sure we were called correctly */
    if (!position)
        return NULL;
    
    /* go to the next entry in the list */
    (*position)++;

    /* Are we beyond the end? */
    if (*position >= nEntryNum)
    {
        /* End of entry.  stop here by returning NULL */
        free(position);
        ifxGetLanStaticCount();
        *my_loop_context = NULL;
        *my_data_context = NULL;
        return NULL;
    }

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = pstWanStaticCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxStaticConfTable_set_indexes(pstWanStaticCfg[*position],
                                          put_index_data);
}

/** Create a data_context for non-existent rows that SETs are performed on.
 *  return a void * pointer which will be passed to subsequent get_XXX
 *  and set_XXX functions for data retrival and modification during
 *  this SET request.
 *
 *  The indexs are encoded (in order) into the index_data pointer if it
 *  would be helpful to use that information.
 */
void           *
ifxStaticConfTable_create_data_context(netsnmp_variable_list *index_data,
                                       int column)
{
#ifdef IFX_ADD_ROW
    /* currently, does not support to add/create row dynamicly. */
    /* printf("**** ifxStaticConfTable_create_data_context ****\n"); */
    pstWanStaticCfg[nEntryNum] =
        (STATICCFG_S *) malloc(sizeof(STATICCFG_S));

    if (!pstWanStaticCfg[nEntryNum])
        return NULL;

    memset (pstWanStaticCfg[nEntryNum], 0x00, sizeof(STATICCFG_S));
    pstWanStaticCfg[nEntryNum]->index = (int) index_data->val.string;

    return pstWanStaticCfg[nEntryNum];
#else
    return NULL;
#endif
}

/** If the implemented set_* functions don't operate directly on the
   real-live data (which is actually recommended), then this function
   can be used to take a given my_data_context pointer and "commit" it
   to whereever the modified data needs to be put back to.  For
   example, if this was a routing table you could publish the modified
   routes back into the kernel at this point.

   new_or_del will be set to 1 if new, or -1 if it should be deleted
   or 0 if it is just a modification of an existing row.

   If you free the data yourself, make sure to *my_data_context = NULL */
int
ifxStaticConfTable_commit_row(void **my_data_context, int new_or_del)
{
    STATICCFG_S             *datactx = *my_data_context;
    char                    sBuf[BUF_SIZE_1K];
    char                    sAliasIpData[MAX_FILELINE_LEN];
    char                    sCount[MAX_DATA_LEN];
    int                     nSetReturn = -1;
    int                     i = 0;
    x_IFX_CM_Msg            xCmMsg;

    /* printf("**** ifxStaticConfTable_commit_row ****\n"); */

    if (new_or_del == -1)
    {
        return SNMP_ERR_NOERROR; /* no change in the value */
    }

    memset (&sBuf, 0x00, BUF_SIZE_1K);
    memset (&sCount, 0x00, MAX_DATA_LEN);

    ifxGetLanStaticCount();

    for (i = 0; i < nEntryNum; i++)
    {
        memset (&sAliasIpData, 0x00, MAX_FILELINE_LEN);

        if (i == datactx->index)
        {
            sprintf (sAliasIpData, "aliasIP%d=\"%s netmask %s broadcast %s\"\n", i,
                     datactx->cIpAddr, datactx->cNetmask, datactx->cGateway);
            strcat (sBuf, sAliasIpData);
        }
        else
        {
            memset (&cRetVal, 0x00, MAX_DATA_LEN);
            memset (&cTag, 0x00, MAX_TAG_LEN);
            sprintf (cTag, "aliasIP%d", i);
        	ifx_GetCfgData(FILE_RC_CONF, "wan_static_alias", cTag, cRetVal);
            sprintf (sAliasIpData, "aliasIP%d=\"%s\"\n", i, cRetVal);
            strcat (sBuf, sAliasIpData);
        }
    }

#ifdef IFX_ADD_ROW
    /* currently, does not support to add/create row dynamicly. */
    if (new_or_del == 1)
    {
        memset (&sAliasIpData, 0x00, MAX_FILELINE_LEN);

        nEntryNum++;
        sprintf (sAliasIpData, "aliasIP%d=\"%s netmask %s broadcast %s\"\n",
                 nEntryNum-1, datactx->cIpAddr, datactx->cNetmask,
                 datactx->cGateway);
        strcat (sBuf, sAliasIpData);
    }
#endif

    sprintf (sCount, "aliasIPCount=\"%d\"\n", nEntryNum);
    strcat (sBuf, sCount);

    nSetReturn = websSetCfgData(FILE_RC_CONF, "wan_static_alias", 1, sBuf);

    if (nSetReturn != 1)
    {
        return SNMP_ERR_COMMITFAILED;
    }

#ifdef IFX_ADD_ROW
    /* currently, does not support to add/create row dynamicly. */
    if (new_or_del == 1)
    {
        if (pstWanStaticCfg[nEntryNum-1])
        {
            free(pstWanStaticCfg[nEntryNum-1]);
            pstWanStaticCfg[nEntryNum-1] = NULL;
        }
    }
#endif

#if defined(ATA) || defined(IIP)
    /* Populate the structure of CM*/
    memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
    xCmMsg.ucMsgType = IFX_CM_SET_REQ;
    xCmMsg.ucInfoType = IFX_CM_APP_NETWORK;
    xCmMsg.uxData.xNetAddrCfg.ucWanIfType = IFX_CM_WAN_IF_FIXED;
    xCmMsg.ucChannel =0;

    strcpy(xCmMsg.uxData.xNetAddrCfg.acIPAddress, datactx->cIpAddr);
    strcpy(xCmMsg.uxData.xNetAddrCfg.acSubnetMask, datactx->cNetmask);
    strcpy(xCmMsg.uxData.xNetAddrCfg.acGatewayAddress, datactx->cGateway);
    snmp_log(LOG_ERR, "ifxStaticConfTable: CM will do reboot.\n");
    if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
    {
    	return SNMP_ERR_COMMITFAILED;
    }
#endif
}


/*
 * User-defined data access functions (per column) for data in table ifxStaticConfTable 
 */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */
/** XXX: return a data pointer to the data for the staticIpAddr column and set
         ret_len to its proper size in bytes. */
char           *
get_staticIpAddr(void *data_context, size_t * ret_len)
{
    STATICCFG_S   *datainfo = (STATICCFG_S *)data_context;
	*ret_len = strlen(datainfo->cIpAddr);
    return (char *) &datainfo->cIpAddr;
}

/** XXX: Set the value of the staticIpAddr column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_staticIpAddr(void *data_context, char *val, size_t val_len)
{
    STATICCFG_S *datainfo = data_context;
    memset(&datainfo->cIpAddr, 0x00, sizeof(datainfo->cIpAddr));
    memcpy(&datainfo->cIpAddr, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the staticNetMask column and set
         ret_len to its proper size in bytes. */
char           *
get_staticNetMask(void *data_context, size_t * ret_len)
{
    STATICCFG_S   *datainfo = (STATICCFG_S *)data_context;
	*ret_len = strlen(datainfo->cNetmask);
    return (char *) &datainfo->cNetmask;
}

/** XXX: Set the value of the staticNetMask column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_staticNetMask(void *data_context, char *val, size_t val_len)
{
    STATICCFG_S *datainfo = data_context;
    memset(&datainfo->cNetmask, 0x00, sizeof(datainfo->cNetmask));
    memcpy(&datainfo->cNetmask, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the staticGateway column and set
         ret_len to its proper size in bytes. */
char           *
get_staticGateway(void *data_context, size_t * ret_len)
{
    STATICCFG_S   *datainfo = (STATICCFG_S *)data_context;
	*ret_len = strlen(datainfo->cGateway);
    return (char *) &datainfo->cGateway;
}

/** XXX: Set the value of the staticGateway column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_staticGateway(void *data_context, char *val, size_t val_len)
{
    STATICCFG_S *datainfo = data_context;
    memset(&datainfo->cGateway, 0x00, sizeof(datainfo->cGateway));
    memcpy(&datainfo->cGateway, val, val_len);
    return SNMP_ERR_NOERROR;
}
