/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *2
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-QOS-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxBuildSwitchTable_access.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "ifxBuildSwitchTable_access.h"

static IFX_MIB_ENUM_S qos_Port_Enum[3] =
{
    {0, "lan"},
    {1, "pc"},
    {2, "ipp"}
};

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
#define MAX_BUILT_SW_NUM    sizeof(qos_Port_Enum)/sizeof(IFX_MIB_ENUM_S)
static QOSBUILTSWCFG_S      stCfg[MAX_BUILT_SW_NUM];
static char                 cTag[MAX_TAG_LEN];
static char                 cRetVal[MAX_DATA_LEN];

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
*/
netsnmp_variable_list *
ifxBuildSwitchTable_set_indexes(QOSBUILTSWCFG_S *datainfo,
                                netsnmp_variable_list *put_index_data)
{
    /* printf("**** ifxBuildSwitchTable_set_indexes ****\n"); */
    netsnmp_variable_list   *vptr;

    vptr = put_index_data;
    snmp_set_var_value(vptr, (u_char *) &datainfo->cSelPort,
                       sizeof(datainfo->cSelPort) );

    return put_index_data;
}

void  *
ifxBuildSwitchTable_get_data(void)
{
    int              i = 0;

    for ( i = 0; i < MAX_BUILT_SW_NUM; i++)
    {
        memset (&stCfg[i], 0x00, sizeof(QOSBUILTSWCFG_S));
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
     	strcpy (stCfg[i].cSelPort, qos_Port_Enum[i].str);

        memset (&cTag, 0x00, MAX_TAG_LEN);
        memset (&cRetVal, 0x00, MAX_DATA_LEN);

        sprintf(cTag, "%s_priority", qos_Port_Enum[i].str);
    	if (ifx_GetCfgData(FILE_RC_CONF, "vlan_port_settings", cTag,
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get nVlanPriority\n"));
    	}
    	stCfg[i].nVlanPriority = atoi(cRetVal);

        memset (&cTag, 0x00, MAX_TAG_LEN);
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
        sprintf(cTag, "%s_port_vid", qos_Port_Enum[i].str);
    	if (ifx_GetCfgData(FILE_RC_CONF, "vlan_port_settings", cTag,
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get nVlanId\n"));
    	}
    	stCfg[i].nVlanId = atoi(cRetVal);

        memset (&cTag, 0x00, MAX_TAG_LEN);
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
        sprintf(cTag, "accept_%s_port", qos_Port_Enum[i].str);
    	if (ifx_GetCfgData(FILE_RC_CONF, "vlan_port_settings", cTag,
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get nAcceptance\n"));
    	}
    	stCfg[i].nAccptance = atoi(cRetVal);

        memset (&cTag, 0x00, MAX_TAG_LEN);
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
        sprintf(cTag, "%s_port", qos_Port_Enum[i].str);
    	if (ifx_GetCfgData(FILE_RC_CONF, "port_priority", cTag,
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get nPortPriority\n"));
    	}
    	stCfg[i].nPortPriority = atoi(cRetVal);
    }
}

/** returns the first data point within the ifxBuildSwitchTable table data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
ifxBuildSwitchTable_get_first_data_point(void **my_loop_context,
                                         void **my_data_context,
                                         netsnmp_variable_list *
                                         put_index_data,
                                         netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxBuildSwitchTable_get_first_data_point ****\n"); */
    int     *position;

    /* we could do this with a file-static variable, but for learning
       purposes we'll use memory allocation to demonstrate simplistic
       freeing of a loop_context */
    position = (int *)malloc(sizeof(int));
    if (!position)
        return NULL;

    ifxBuildSwitchTable_get_data();

    /* We use the positinonal count as our loop context */
    *position = 0;
    *my_loop_context = position;

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = &stCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxBuildSwitchTable_set_indexes(&stCfg[*position], put_index_data);
}

/** functionally the same as ifxBuildSwitchTable_get_first_data_point, but
   my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
ifxBuildSwitchTable_get_next_data_point(void **my_loop_context,
                                        void **my_data_context,
                                        netsnmp_variable_list *
                                        put_index_data,
                                        netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxBuildSwitchTable_get_next_data_point ****\n"); */
    int *position = (int *) *my_loop_context;

    /* make sure we were called correctly */
    if (!position)
        return NULL;
    
    /* go to the next entry in the list */
    (*position)++;

    /* Are we beyond the end? */
    if (*position >= MAX_BUILT_SW_NUM)
    {
        /* End of entry.  stop here by returning NULL */
        free(position);
        *my_loop_context = NULL;
        *my_data_context = NULL;
        return NULL;
    }

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = &stCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxBuildSwitchTable_set_indexes(&stCfg[*position], put_index_data);
}

/** Create a data_context for non-existent rows that SETs are performed on.
 *  return a void * pointer which will be passed to subsequent get_XXX
 *  and set_XXX functions for data retrival and modification during
 *  this SET request.
 *
 *  The indexs are encoded (in order) into the index_data pointer if it
 *  would be helpful to use that information.
 */
void           *
ifxBuildSwitchTable_create_data_context(netsnmp_variable_list *
                                        index_data, int column)
{
    return NULL;                /* XXX: you likely want to return a real pointer */
}

/** If the implemented set_* functions don't operate directly on the
   real-live data (which is actually recommended), then this function
   can be used to take a given my_data_context pointer and "commit" it
   to whereever the modified data needs to be put back to.  For
   example, if this was a routing table you could publish the modified
   routes back into the kernel at this point.

   new_or_del will be set to 1 if new, or -1 if it should be deleted
   or 0 if it is just a modification of an existing row.

   If you free the data yourself, make sure to *my_data_context = NULL */
int
ifxBuildSwitchTable_commit_row(void **my_data_context, int new_or_del)
{
    QOSBUILTSWCFG_S         *datactx = *my_data_context;
    char                    sVlanPortSet[BUF_SIZE_1K];
    char                    sPortPrioSet[BUF_SIZE_1K];
    char                    sTemp[MAX_DATA_LEN];
    int                     nSetReturn = -1;
    int                     i = 0;

    /* printf("**** ifxBuildSwitchTable_commit_row ****\n"); */

    if (new_or_del == -1)
    {
        return SNMP_ERR_NOERROR; /* no change in the value */
    }

    memset (&sVlanPortSet, 0x00, BUF_SIZE_1K);
    memset (&sPortPrioSet, 0x00, BUF_SIZE_1K);

    memset (&cRetVal, 0x00, MAX_DATA_LEN);
    memset (&sTemp, 0x00, MAX_DATA_LEN);
	if (ifx_GetCfgData(FILE_RC_CONF, "port_priority", "port_priority_status",
	                   cRetVal) != 1)
	{
        snmp_log(LOG_ERR, "bwQueueAssign: unable get nQueueAssign\n");
	}
	sprintf (sTemp, "port_priority_status=\"%s\"\n", cRetVal);
	strcat (sPortPrioSet, sTemp);

    for (i = 0; i < MAX_BUILT_SW_NUM; i++)
    {
        if ( strcmp( qos_Port_Enum[i].str, datactx->cSelPort) == 0)
        {
            /* VLAN priority */
            memset (&cTag, 0x00, MAX_TAG_LEN);
            memset (&sTemp, 0x00, MAX_DATA_LEN);
            sprintf(cTag, "%s_priority", qos_Port_Enum[i].str);
            sprintf (sTemp, "%s=\"%d\"\n", cTag, datactx->nVlanPriority);
            strcat (sVlanPortSet, sTemp);

            /* VLAN ID */
            memset (&cTag, 0x00, MAX_TAG_LEN);
            memset (&sTemp, 0x00, MAX_DATA_LEN);
            sprintf(cTag, "%s_port_vid", qos_Port_Enum[i].str);
            sprintf (sTemp, "%s=\"%d\"\n", cTag, datactx->nVlanId);
            strcat (sVlanPortSet, sTemp);

            /* Acceptance */
            memset (&cTag, 0x00, MAX_TAG_LEN);
            memset (&sTemp, 0x00, MAX_DATA_LEN);
            sprintf(cTag, "accept_%s_port", qos_Port_Enum[i].str);
            sprintf (sTemp, "%s=\"%d\"\n", cTag, datactx->nAccptance);
            strcat (sVlanPortSet, sTemp);

            /* Prot Priority */
            memset (&cTag, 0x00, MAX_TAG_LEN);
            memset (&sTemp, 0x00, MAX_DATA_LEN);
            sprintf(cTag, "%s_port", qos_Port_Enum[i].str);
            sprintf (sTemp, "%s=\"%d\"\n", cTag, datactx->nPortPriority);
            strcat (sPortPrioSet, sTemp);
        }
        else
        {
            /* VLAN priority */
            memset (&cTag, 0x00, MAX_TAG_LEN);
            memset (&cRetVal, 0x00, MAX_DATA_LEN);
            memset (&sTemp, 0x00, MAX_DATA_LEN);
            sprintf(cTag, "%s_priority", qos_Port_Enum[i].str);
    	    ifx_GetCfgData(FILE_RC_CONF, "vlan_port_settings", cTag, cRetVal);
            sprintf (sTemp, "%s=\"%s\"\n", cTag, cRetVal);
            strcat (sVlanPortSet, sTemp);

            /* VLAN ID */
            memset (&cTag, 0x00, MAX_TAG_LEN);
            memset (&cRetVal, 0x00, MAX_DATA_LEN);
            memset (&sTemp, 0x00, MAX_DATA_LEN);
            sprintf(cTag, "%s_port_vid", qos_Port_Enum[i].str);
    	    ifx_GetCfgData(FILE_RC_CONF, "vlan_port_settings", cTag, cRetVal);
            sprintf (sTemp, "%s=\"%s\"\n", cTag, cRetVal);
            strcat (sVlanPortSet, sTemp);

            /* Acceptance */
            memset (&cTag, 0x00, MAX_TAG_LEN);
            memset (&cRetVal, 0x00, MAX_DATA_LEN);
            memset (&sTemp, 0x00, MAX_DATA_LEN);
            sprintf(cTag, "accept_%s_port", qos_Port_Enum[i].str);
    	    ifx_GetCfgData(FILE_RC_CONF, "vlan_port_settings", cTag, cRetVal);
            sprintf (sTemp, "%s=\"%s\"\n", cTag, cRetVal);
            strcat (sVlanPortSet, sTemp);

            /* Prot Priority */
            memset (&cTag, 0x00, MAX_TAG_LEN);
            memset (&cRetVal, 0x00, MAX_DATA_LEN);
            memset (&sTemp, 0x00, MAX_DATA_LEN);
            sprintf(cTag, "%s_port", qos_Port_Enum[i].str);
    	    ifx_GetCfgData(FILE_RC_CONF, "port_priority", cTag, cRetVal);
            sprintf (sTemp, "%s=\"%s\"\n", cTag, cRetVal);
            strcat (sPortPrioSet, sTemp);
        }
    }

    nSetReturn = websSetCfgData(FILE_RC_CONF, "vlan_port_settings", 1,
                                sVlanPortSet);

    if (nSetReturn != 1)
    {
        return SNMP_ERR_COMMITFAILED;
    }

    nSetReturn = -1;
    nSetReturn = websSetCfgData(FILE_RC_CONF, "port_priority", 1, sPortPrioSet);

    if (nSetReturn != 1)
    {
        return SNMP_ERR_COMMITFAILED;
    }

    /*
     * return no errors.  And there shouldn't be any!!!  Ever!!!  You
     * should have checked the values long before this. 
     */
    return SNMP_ERR_NOERROR;
}


/*
 * User-defined data access functions (per column) for data in table ifxBuildSwitchTable 
 */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */
/** XXX: return a data pointer to the data for the bwVlanPriority column and set
         ret_len to its proper size in bytes. */
int           *
get_bwVlanPriority(void *data_context, size_t * ret_len)
{
    QOSBUILTSWCFG_S   *datainfo = data_context;
    *ret_len = sizeof(datainfo->nVlanPriority);  /* XXX: make sure it's 4 */
    return &datainfo->nVlanPriority;
}

/** XXX: Set the value of the bwVlanPriority column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_bwVlanPriority(void *data_context, int *val, size_t val_len)
{
    QOSBUILTSWCFG_S *datainfo = data_context;
    datainfo->nVlanPriority = 0;
    memcpy(&datainfo->nVlanPriority, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the bwVlanId column and set
         ret_len to its proper size in bytes. */
int           *
get_bwVlanId(void *data_context, size_t * ret_len)
{
    QOSBUILTSWCFG_S *datainfo = data_context;
    *ret_len = sizeof(datainfo->nVlanId);
    return &datainfo->nVlanId;
}

/** XXX: Set the value of the bwVlanId column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_bwVlanId(void *data_context, int *val, size_t val_len)
{
    QOSBUILTSWCFG_S *datainfo = data_context;
    datainfo->nVlanId = 0;
    memcpy(&datainfo->nVlanId, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the bwAcceptance column and set
         ret_len to its proper size in bytes. */
int           *
get_bwAcceptance(void *data_context, size_t * ret_len)
{
    QOSBUILTSWCFG_S *datainfo = data_context;
    *ret_len = sizeof(datainfo->nAccptance);
    return &datainfo->nAccptance;
}

/** XXX: Set the value of the bwAcceptance column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_bwAcceptance(void *data_context, int *val, size_t val_len)
{
    QOSBUILTSWCFG_S *datainfo = data_context;
    datainfo->nAccptance = 0;
    memcpy(&datainfo->nAccptance, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the bwPortPriority column and set
         ret_len to its proper size in bytes. */
int           *
get_bwPortPriority(void *data_context, size_t * ret_len)
{
    QOSBUILTSWCFG_S *datainfo = data_context;
    *ret_len = sizeof(datainfo->nPortPriority);
    return &datainfo->nPortPriority;
}

/** XXX: Set the value of the bwPortPriority column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_bwPortPriority(void *data_context, int *val, size_t val_len)
{
    QOSBUILTSWCFG_S *datainfo = data_context;
    datainfo->nPortPriority = 0;
    memcpy(&datainfo->nPortPriority, val, val_len);
    return SNMP_ERR_NOERROR;
}
