/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-VOIP-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxMediaSecProfTable.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.iterate_access.conf,v 1.11 2004/08/31 10:23:16 dts12 Exp $
*/
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "ifxMediaSecProfTable.h"
#include "ifxMediaSecProfTable_checkfns.h"
#include "ifxMediaSecProfTable_access.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
static netsnmp_oid_stash_node *undoStorage = NULL;
static netsnmp_oid_stash_node *commitStorage = NULL;

struct undoInfo {
    void           *ptr;
    size_t          len;
};

struct commitInfo {
    void           *data_context;
    int             have_committed;
    int             new_row;
};

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
*/
void
ifxMediaSecProfTable_free_undoInfo(void *vptr)
{
    struct undoInfo *ui = vptr;
    if (!ui)
        return;
    SNMP_FREE(ui->ptr);
    SNMP_FREE(ui);
}

/** Initialize the ifxMediaSecProfTable table by defining its contents and how it's structured */
void
initialize_table_ifxMediaSecProfTable(void)
{
    static oid      ifxMediaSecProfTable_oid[] =
        { 1, 3, 6, 1, 4, 1, IFX_MIB, IFX_PRODUCT, 2, 10 };
    netsnmp_table_registration_info *table_info;
    netsnmp_handler_registration *my_handler;
    netsnmp_iterator_info *iinfo;

    /** create the table registration information structures */
    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);

    my_handler =
        netsnmp_create_handler_registration("ifxMediaSecProfTable",
                                            ifxMediaSecProfTable_handler,
                                            ifxMediaSecProfTable_oid,
                                            OID_LENGTH
                                            (ifxMediaSecProfTable_oid),
                                            HANDLER_CAN_RWRITE);

    if (!my_handler || !table_info || !iinfo) {

#ifdef IIP_MEM_LEAK_FIX
         if (my_handler)
            SNMP_FREE(my_handler);
         if (table_info)
            SNMP_FREE(table_info);
          if (iinfo)
            SNMP_FREE(iinfo);
#endif
        snmp_log(LOG_ERR,\
                 "malloc failed in initialize_table_ifxMediaSecProfTable");
        return; /** Serious error. */
    }

    /***************************************************
     * Setting up the table's definition
     */
    netsnmp_table_helper_add_indexes(table_info, ASN_UNSIGNED,
                                               /** index: endPointIndex */
                                     ASN_OCTET_STR,
                                                 /** index: suUserName */
                                     ASN_OCTET_STR,
                                                 /** index: suDomainName */
                                     ASN_UNSIGNED,
                                               /** index: mspIndex */
                                     0);

    /** Define the minimum and maximum accessible columns.  This
        optimizes retrival. */
    table_info->min_column = COLUMN_MSPSRTPENCRYALGO;
    table_info->max_column = COLUMN_MSPROWSTATUS;

    /** iterator access routines */
    iinfo->get_first_data_point =
        ifxMediaSecProfTable_get_first_data_point;
    iinfo->get_next_data_point = ifxMediaSecProfTable_get_next_data_point;

    /** you may wish to set these as well */
#ifdef MAYBE_USE_THESE
    iinfo->make_data_context =
        ifxMediaSecProfTable_context_convert_function;
    iinfo->free_data_context = ifxMediaSecProfTable_data_free;

    /** pick *only* one of these if you use them */
    iinfo->free_loop_context = ifxMediaSecProfTable_loop_free;
    iinfo->free_loop_context_at_end = ifxMediaSecProfTable_loop_free;
#endif

    /** tie the two structures together */
    iinfo->table_reginfo = table_info;

    /***************************************************
     * registering the table with the master agent
     */
    DEBUGMSGTL(("initialize_table_ifxMediaSecProfTable",
                "Registering table ifxMediaSecProfTable as a table iterator\n"));
    netsnmp_register_table_iterator(my_handler, iinfo);
}

/** Initializes the ifxMediaSecProfTable module */
void
init_ifxMediaSecProfTable(void)
{
    /** here we initialize all the tables we're planning on supporting */
    initialize_table_ifxMediaSecProfTable();
}

/** handles requests for the ifxMediaSecProfTable table, if anything else needs to be done */
int
ifxMediaSecProfTable_handler(netsnmp_mib_handler *handler,
                             netsnmp_handler_registration *reginfo,
                             netsnmp_agent_request_info *reqinfo,
                             netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    netsnmp_variable_list *var;
    struct commitInfo *ci = NULL;
    void           *data_context = NULL;
    oid            *suffix;
    size_t          suffix_len;

    for (request = requests; request; request = request->next)
    {
        /** column and row index encoded portion */
        var = request->requestvb;
        suffix = var->name + reginfo->rootoid_len + 1;
        suffix_len = var->name_length - (reginfo->rootoid_len + 1);
        if (request->processed != 0)
            continue;

        switch (reqinfo->mode) {
        case MODE_GET:
            data_context = netsnmp_extract_iterator_context(request);
            if (data_context == NULL) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
            }
            break;

        case MODE_SET_RESERVE1:
            data_context = netsnmp_extract_iterator_context(request);
            if (data_context == NULL) {
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_ERR_NOCREATION);
                continue;
            }
            break;

        default:               /* == the other SET modes */
            ci = netsnmp_oid_stash_get_data(commitStorage,
                                            suffix + 1, suffix_len - 1);
            break;
        }

        /** extracts the information about the table from the request */
        table_info = netsnmp_extract_table_info(request);
        /** table_info->colnum contains the column number requested */
        /** table_info->indexes contains a linked list of snmp variable
           bindings for the indexes of the table.  Values in the list
           have been set corresponding to the indexes of the
           request */
        if (table_info == NULL) {
            continue;
        }

        switch (reqinfo->mode) {
        case MODE_GET:
            switch (table_info->colnum) {
            case COLUMN_MSPSRTPENCRYALGO:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    retval =
                        get_mspSRTPEncryAlgo(data_context, &retval_len);
                    if (retval)
                        snmp_set_var_typed_value(var, ASN_UNSIGNED,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_MSPSRTPAUTHALGO:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    retval =
                        get_mspSRTPAuthAlgo(data_context, &retval_len);
                    if (retval)
                        snmp_set_var_typed_value(var, ASN_UNSIGNED,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_MSPSRTPMASTERKEY:
                {
                    char           *retval;
                    size_t          retval_len = 0;
                    retval =
                        get_mspSRTPMasterKey(data_context, &retval_len);
                    if (retval)
                    snmp_set_var_typed_value(var, ASN_OCTET_STR,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_MSPSRTPMASTERSALT:
                {
                    char           *retval;
                    size_t          retval_len = 0;
                    retval =
                        get_mspSRTPMasterSalt(data_context, &retval_len);
                    if (retval)
                    snmp_set_var_typed_value(var, ASN_OCTET_STR,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_MSPSRTPMKIFLAG:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    retval = get_mspSRTPMKIFlag(data_context, &retval_len);
                    if (retval)
                        snmp_set_var_typed_value(var, ASN_UNSIGNED,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_MSPSRTPMKI:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    retval = get_mspSRTPMKI(data_context, &retval_len);
                    if (retval)
                        snmp_set_var_typed_value(var, ASN_UNSIGNED,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_MSPSRTCPENCRYALGO:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    retval =
                        get_mspSRTCPEncryAlgo(data_context, &retval_len);
                    if (retval)
                        snmp_set_var_typed_value(var, ASN_UNSIGNED,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_MSPSRTCPAUTHALGO:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    retval =
                        get_mspSRTCPAuthAlgo(data_context, &retval_len);
                    if (retval)
                        snmp_set_var_typed_value(var, ASN_UNSIGNED,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_MSPSRTCPMASTERKEY:
                {
                    char           *retval;
                    size_t          retval_len = 0;
                    retval =
                        get_mspSRTCPMasterKey(data_context, &retval_len);
                    if (retval)
                    snmp_set_var_typed_value(var, ASN_OCTET_STR,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_MSPSRTCPMASTERSALT:
                {
                    char           *retval;
                    size_t          retval_len = 0;
                    retval =
                        get_mspSRTCPMasterSalt(data_context, &retval_len);
                    if (retval)
                    snmp_set_var_typed_value(var, ASN_OCTET_STR,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_MSPSRTCPMKIFLAG:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    retval =
                        get_mspSRTCPMKIFlag(data_context, &retval_len);
                    if (retval)
                        snmp_set_var_typed_value(var, ASN_UNSIGNED,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_MSPSRTCPMKI:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    retval = get_mspSRTCPMKI(data_context, &retval_len);
                    if (retval)
                        snmp_set_var_typed_value(var, ASN_UNSIGNED,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_MSPROWSTATUS:
                {
                    long           *retval;
                    size_t          retval_len = 0;
                    retval = get_mspRowStatus(data_context, &retval_len);
                    if (retval)
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            default:
                /** We shouldn't get here */
                snmp_log(LOG_ERR,
                         "problem encountered in ifxMediaSecProfTable_handler: unknown column\n");
            }
            break;

        case MODE_SET_RESERVE1:
            ci = netsnmp_oid_stash_get_data(commitStorage,
                                            suffix + 1, suffix_len - 1);

            if (!ci) {
                    /** create the commit storage info */
                ci = SNMP_MALLOC_STRUCT(commitInfo);
                if (!data_context) {
                    ci->data_context =
                        ifxMediaSecProfTable_create_data_context
                        (table_info->indexes, table_info->colnum);
                    ci->new_row = 1;
                } else {
                    ci->data_context = data_context;
                }
                netsnmp_oid_stash_add_data(&commitStorage,
                                           suffix + 1, suffix_len - 1, ci);
            }
            break;

        case MODE_SET_RESERVE2:
            switch (table_info->colnum) {
            case COLUMN_MSPSRTPENCRYALGO:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;

                    /** first, get the old value */
                    retval =
                        get_mspSRTPEncryAlgo(ci->data_context,
                                             &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    /** check the new value, possibly against the
                        older value for a valid state transition */
                    ret = check_mspSRTPEncryAlgo(var->type,
                                                 (u_long *) var->val.string,
                                                 var->
                                                 val_len, retval,
                                                 retval_len);
                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxMediaSecProfTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            case COLUMN_MSPSRTPAUTHALGO:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;

                    /** first, get the old value */
                    retval =
                        get_mspSRTPAuthAlgo(ci->data_context, &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    /** check the new value, possibly against the
                        older value for a valid state transition */
                    ret = check_mspSRTPAuthAlgo(var->type,
                                                (u_long *) var->val.string,
                                                var->
                                                val_len, retval,
                                                retval_len);
                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxMediaSecProfTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            case COLUMN_MSPSRTPMASTERKEY:
                {
                    char           *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;

                    /** first, get the old value */
                    retval =
                        get_mspSRTPMasterKey(ci->data_context,
                                             &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    /** check the new value, possibly against the
                        older value for a valid state transition */
                    ret = check_mspSRTPMasterKey(var->type,
                                                 (char *) var->val.string,
                                                 var->
                                                 val_len, retval,
                                                 retval_len);
                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxMediaSecProfTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            case COLUMN_MSPSRTPMASTERSALT:
                {
                    char           *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;

                    /** first, get the old value */
                    retval =
                        get_mspSRTPMasterSalt(ci->data_context,
                                              &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    /** check the new value, possibly against the
                        older value for a valid state transition */
                    ret = check_mspSRTPMasterSalt(var->type,
                                                  (char *) var->val.string,
                                                  var->
                                                  val_len, retval,
                                                  retval_len);
                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxMediaSecProfTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            case COLUMN_MSPSRTPMKIFLAG:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;

                    /** first, get the old value */
                    retval =
                        get_mspSRTPMKIFlag(ci->data_context, &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    /** check the new value, possibly against the
                        older value for a valid state transition */
                    ret = check_mspSRTPMKIFlag(var->type,
                                               (u_long *) var->val.string,
                                               var->val_len,
                                               retval, retval_len);
                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxMediaSecProfTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            case COLUMN_MSPSRTPMKI:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;

                    /** first, get the old value */
                    retval = get_mspSRTPMKI(ci->data_context, &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    /** check the new value, possibly against the
                        older value for a valid state transition */
                    ret = check_mspSRTPMKI(var->type,
                                           (u_long *) var->
                                           val.string,
                                           var->val_len,
                                           retval, retval_len);
                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxMediaSecProfTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            case COLUMN_MSPSRTCPENCRYALGO:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;

                    /** first, get the old value */
                    retval =
                        get_mspSRTCPEncryAlgo(ci->data_context,
                                              &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    /** check the new value, possibly against the
                        older value for a valid state transition */
                    ret = check_mspSRTCPEncryAlgo(var->type,
                                                  (u_long *) var->val.string,
                                                  var->
                                                  val_len, retval,
                                                  retval_len);
                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxMediaSecProfTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            case COLUMN_MSPSRTCPAUTHALGO:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;

                    /** first, get the old value */
                    retval =
                        get_mspSRTCPAuthAlgo(ci->data_context,
                                             &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    /** check the new value, possibly against the
                        older value for a valid state transition */
                    ret = check_mspSRTCPAuthAlgo(var->type,
                                                 (u_long *) var->val.string,
                                                 var->
                                                 val_len, retval,
                                                 retval_len);
                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxMediaSecProfTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            case COLUMN_MSPSRTCPMASTERKEY:
                {
                    char           *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;

                    /** first, get the old value */
                    retval =
                        get_mspSRTCPMasterKey(ci->data_context,
                                              &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    /** check the new value, possibly against the
                        older value for a valid state transition */
                    ret = check_mspSRTCPMasterKey(var->type,
                                                  (char *) var->val.string,
                                                  var->
                                                  val_len, retval,
                                                  retval_len);
                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxMediaSecProfTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            case COLUMN_MSPSRTCPMASTERSALT:
                {
                    char           *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;

                    /** first, get the old value */
                    retval =
                        get_mspSRTCPMasterSalt(ci->data_context,
                                               &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    /** check the new value, possibly against the
                        older value for a valid state transition */
                    ret =
                        check_mspSRTCPMasterSalt(var->type,
                                                 (char *) var->val.string,
                                                 var->
                                                 val_len, retval,
                                                 retval_len);
                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxMediaSecProfTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            case COLUMN_MSPSRTCPMKIFLAG:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;

                    /** first, get the old value */
                    retval =
                        get_mspSRTCPMKIFlag(ci->data_context, &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    /** check the new value, possibly against the
                        older value for a valid state transition */
                    ret = check_mspSRTCPMKIFlag(var->type,
                                                (u_long *) var->val.string,
                                                var->
                                                val_len, retval,
                                                retval_len);
                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxMediaSecProfTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            case COLUMN_MSPSRTCPMKI:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;

                    /** first, get the old value */
                    retval =
                        get_mspSRTCPMKI(ci->data_context, &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    /** check the new value, possibly against the
                        older value for a valid state transition */
                    ret = check_mspSRTCPMKI(var->type,
                                            (u_long *) var->val.string,
                                            var->val_len,
                                            retval, retval_len);
                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxMediaSecProfTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            case COLUMN_MSPROWSTATUS:
                {
                    long           *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;

                    /** first, get the old value */
                    retval =
                        get_mspRowStatus(ci->data_context, &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    /** check the new value, possibly against the
                        older value for a valid state transition */
                    ret = check_mspRowStatus(var->type,
                                             (long *) var->val.string,
                                             var->val_len,
                                             retval, retval_len);
                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxMediaSecProfTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_ERR_NOTWRITABLE);
                break;
            }
            break;

        case MODE_SET_ACTION:
            /** save a variable copy */
            switch (table_info->colnum) {
            case COLUMN_MSPSRTPENCRYALGO:
                {
                    int             ret;
                    ret = set_mspSRTPEncryAlgo(ci->data_context,
                                               (u_long *) var->val.string,
                                               var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                }
                break;
            case COLUMN_MSPSRTPAUTHALGO:
                {
                    int             ret;
                    ret = set_mspSRTPAuthAlgo(ci->data_context,
                                              (u_long *) var->val.string,
                                              var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                }
                break;
            case COLUMN_MSPSRTPMASTERKEY:
                {
                    int             ret;
                    ret = set_mspSRTPMasterKey(ci->data_context,
                                               (char *) var->val.string,
                                               var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                }
                break;
            case COLUMN_MSPSRTPMASTERSALT:
                {
                    int             ret;
                    ret = set_mspSRTPMasterSalt(ci->data_context,
                                                (char *) var->val.string,
                                                var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                }
                break;
            case COLUMN_MSPSRTPMKIFLAG:
                {
                    int             ret;
                    ret = set_mspSRTPMKIFlag(ci->data_context,
                                             (u_long *) var->val.string,
                                             var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                }
                break;
            case COLUMN_MSPSRTPMKI:
                {
                    int             ret;
                    ret = set_mspSRTPMKI(ci->data_context,
                                         (u_long *) var->val.string,
                                         var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                }
                break;
            case COLUMN_MSPSRTCPENCRYALGO:
                {
                    int             ret;
                    ret = set_mspSRTCPEncryAlgo(ci->data_context,
                                                (u_long *) var->val.string,
                                                var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                }
                break;
            case COLUMN_MSPSRTCPAUTHALGO:
                {
                    int             ret;
                    ret = set_mspSRTCPAuthAlgo(ci->data_context,
                                               (u_long *) var->val.string,
                                               var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                }
                break;
            case COLUMN_MSPSRTCPMASTERKEY:
                {
                    int             ret;
                    ret = set_mspSRTCPMasterKey(ci->data_context,
                                                (char *) var->val.string,
                                                var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                }
                break;
            case COLUMN_MSPSRTCPMASTERSALT:
                {
                    int             ret;
                    ret = set_mspSRTCPMasterSalt(ci->data_context,
                                                 (char *) var->val.string,
                                                 var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                }
                break;
            case COLUMN_MSPSRTCPMKIFLAG:
                {
                    int             ret;
                    ret = set_mspSRTCPMKIFlag(ci->data_context,
                                              (u_long *) var->val.string,
                                              var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                }
                break;
            case COLUMN_MSPSRTCPMKI:
                {
                    int             ret;
                    ret = set_mspSRTCPMKI(ci->data_context,
                                          (u_long *) var->val.string,
                                          var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                }
                break;
            case COLUMN_MSPROWSTATUS:
                {
                    int             ret;
                    ret = set_mspRowStatus(ci->data_context,
                                           (long *) var->
                                           val.string,
                                           var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                    if (*var->val.integer == RS_DESTROY) {
                        ci->new_row = -1;
                    }
                }
                break;
            }
            break;

        case MODE_SET_COMMIT:
            if (!ci->have_committed) {
                    /** do this once per row only */
                ifxMediaSecProfTable_commit_row(&ci->data_context,
                                                ci->new_row);
                ci->have_committed = 1;
            }
            break;

        case MODE_SET_UNDO:
             /** save a variable copy */
            switch (table_info->colnum) {
            case COLUMN_MSPSRTPENCRYALGO:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval =
                        set_mspSRTPEncryAlgo(ci->data_context, ui->ptr,
                                             ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            case COLUMN_MSPSRTPAUTHALGO:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval = set_mspSRTPAuthAlgo(ci->data_context, ui->ptr,
                                                 ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            case COLUMN_MSPSRTPMASTERKEY:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval =
                        set_mspSRTPMasterKey(ci->data_context, ui->ptr,
                                             ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            case COLUMN_MSPSRTPMASTERSALT:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval =
                        set_mspSRTPMasterSalt(ci->data_context, ui->ptr,
                                              ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            case COLUMN_MSPSRTPMKIFLAG:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval = set_mspSRTPMKIFlag(ci->data_context, ui->ptr,
                                                ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            case COLUMN_MSPSRTPMKI:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval = set_mspSRTPMKI(ci->data_context, ui->ptr,
                                            ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            case COLUMN_MSPSRTCPENCRYALGO:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval =
                        set_mspSRTCPEncryAlgo(ci->data_context, ui->ptr,
                                              ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            case COLUMN_MSPSRTCPAUTHALGO:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval =
                        set_mspSRTCPAuthAlgo(ci->data_context, ui->ptr,
                                             ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            case COLUMN_MSPSRTCPMASTERKEY:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval =
                        set_mspSRTCPMasterKey(ci->data_context, ui->ptr,
                                              ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            case COLUMN_MSPSRTCPMASTERSALT:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval =
                        set_mspSRTCPMasterSalt(ci->data_context, ui->ptr,
                                               ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            case COLUMN_MSPSRTCPMKIFLAG:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval = set_mspSRTCPMKIFlag(ci->data_context, ui->ptr,
                                                 ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            case COLUMN_MSPSRTCPMKI:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval = set_mspSRTCPMKI(ci->data_context, ui->ptr,
                                             ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            case COLUMN_MSPROWSTATUS:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval = set_mspRowStatus(ci->data_context, ui->ptr,
                                              ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            }
            break;

        case MODE_SET_FREE:
            break;

        default:
            snmp_log(LOG_ERR,
                     "problem encountered in ifxMediaSecProfTable_handler: unsupported mode\n");
        }
    }

    /** clean up after all requset processing has ended */
    switch (reqinfo->mode) {
    case MODE_SET_UNDO:
    case MODE_SET_FREE:
    case MODE_SET_COMMIT:
        /** clear out the undo cache */
        netsnmp_oid_stash_free(&undoStorage,
                               ifxMediaSecProfTable_free_undoInfo);
        netsnmp_oid_stash_free(&commitStorage, netsnmp_oid_stash_no_free);
    }

    return SNMP_ERR_NOERROR;
}
