/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-VOIP-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxSipUserTable_access.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.9 2004/10/14 12:57:33 dts12 Exp $
*/
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "ifxSipUserTable_access.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
static VOIPSIPUSERCFG_S     stCfg[IFX_CM_MAX_ENDPTS];
static x_IFX_CM_Msg         g_xCmMsg;

netsnmp_variable_list *
ifxSipUserTable_set_indexes(VOIPSIPUSERCFG_S *datainfo,
                            netsnmp_variable_list *put_index_data)
{
    /* printf("**** ifxSipUserTable_set_indexes ****\n"); */
    netsnmp_variable_list   *vptr;

    /* endPointIdx */
    vptr = put_index_data;
    snmp_set_var_value(vptr, (u_char *) &datainfo->ulEndPointIdx,
                       sizeof(datainfo->ulEndPointIdx) );

    /* suUserName */
    vptr = vptr->next_variable;
    snmp_set_var_value(vptr, (u_char *) &datainfo->cUserName,
                       strlen(datainfo->cUserName) );

    /* suDomainName */
    vptr = vptr->next_variable;
    snmp_set_var_value(vptr, (u_char *) &datainfo->cDomainName,
                       strlen(datainfo->cDomainName) );

    return put_index_data;
}

void  *
ifxSipUserTable_get_data(void)
{
    int              i = 0;

    for ( i = 0; i < IFX_CM_MAX_ENDPTS; i++)
    {
        memset (&stCfg[i], 0x00, sizeof(VOIPSIPUSERCFG_S));
        memset (&g_xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));

       	g_xCmMsg.ucMsgType = IFX_CM_GET_REQ;
    	g_xCmMsg.ucInfoType = IFX_CM_SIP_CFG_USER;
    	g_xCmMsg.ucChannel = i;
    
        if (IFX_CM_RecvDataFromCM (&g_xCmMsg) != IFX_CM_SUCCESS)
        {
            snmp_log(LOG_ERR,"ifxSipUserTable: Fail to receive data from CM\n");
        }

        stCfg[i].ulEndPointIdx = g_xCmMsg.ucChannel;
        strncpy (stCfg[i].cUserName,
                 g_xCmMsg.uxData.xSipUserCfg.acUserName,
                 strlen(g_xCmMsg.uxData.xSipUserCfg.acUserName));
        strncpy (stCfg[i].cDomainName,
                 g_xCmMsg.uxData.xSipUserCfg.acDomain,
                 strlen(g_xCmMsg.uxData.xSipUserCfg.acDomain));
        strncpy (stCfg[i].cDisplayName,
                 g_xCmMsg.uxData.xSipUserCfg.acDisplayName,
                 strlen(g_xCmMsg.uxData.xSipUserCfg.acDisplayName));
        strncpy (stCfg[i].cAuthName,
                 g_xCmMsg.uxData.xSipUserCfg.acAuthUserName,
                 strlen(g_xCmMsg.uxData.xSipUserCfg.acAuthUserName));
        strncpy (stCfg[i].cAuthPasswd,
                 g_xCmMsg.uxData.xSipUserCfg.acPasswd,
                 strlen(g_xCmMsg.uxData.xSipUserCfg.acPasswd));
        stCfg[i].ulRegStatus = g_xCmMsg.uxData.xSipUserCfg.ucRegStatus;
        if (stCfg[i].ulRegStatus == IFX_CM_REG_INACTIVE)
            stCfg[i].lRowStatus = ROWSTATUS_NOTINSERVICE;
        else
            stCfg[i].lRowStatus = ROWSTATUS_ACTIVE;
    }
}

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
*/
/** returns the first data point within the ifxSipUserTable table data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
ifxSipUserTable_get_first_data_point(void **my_loop_context,
                                     void **my_data_context,
                                     netsnmp_variable_list *
                                     put_index_data,
                                     netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxSipUserTable_get_first_data_point ****\n"); */
    int     *position;

    /* we could do this with a file-static variable, but for learning
       purposes we'll use memory allocation to demonstrate simplistic
       freeing of a loop_context */
    position = (int *)malloc(sizeof(int));
    if (!position)
        return NULL;

    ifxSipUserTable_get_data();

    /* We use the positinonal count as our loop context */
    *position = 0;
    *my_loop_context = position;

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = &stCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxSipUserTable_set_indexes(&stCfg[*position], put_index_data);
}

/** functionally the same as ifxSipUserTable_get_first_data_point, but
   my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
ifxSipUserTable_get_next_data_point(void **my_loop_context,
                                    void **my_data_context,
                                    netsnmp_variable_list * put_index_data,
                                    netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxSipUserTable_get_next_data_point ****\n"); */
    int *position = (int *) *my_loop_context;

    /* make sure we were called correctly */
    if (!position)
        return NULL;
    
    /* go to the next entry in the list */
    (*position)++;

    /* Are we beyond the end? */
    if (*position >= IFX_CM_MAX_ENDPTS)
    {
        /* End of entry.  stop here by returning NULL */
        free(position);
        *my_loop_context = NULL;
        *my_data_context = NULL;
        return NULL;
    }

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = &stCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxSipUserTable_set_indexes(&stCfg[*position], put_index_data);
}

/** Create a data_context for non-existent rows that SETs are performed on.
 *  return a void * pointer which will be passed to subsequent get_XXX
 *  and set_XXX functions for data retrival and modification during
 *  this SET request.
 *
 *  The indexes are encoded (in order) into the index_data pointer,
 *  and the column object which triggered the row creation is available
 *  via the column parameter, if it would be helpful to use that information.
 */
void           *
ifxSipUserTable_create_data_context(netsnmp_variable_list * index_data,
                                    int column)
{
    return NULL;                /* XXX: you likely want to return a real pointer */
}

/** If the implemented set_* functions don't operate directly on the
   real-live data (which is actually recommended), then this function
   can be used to take a given my_data_context pointer and "commit" it
   to whereever the modified data needs to be put back to.  For
   example, if this was a routing table you could publish the modified
   routes back into the kernel at this point.

   new_or_del will be set to 1 if new, or -1 if it should be deleted
   or 0 if it is just a modification of an existing row.

   If you free the data yourself, make sure to *my_data_context = NULL */
int
ifxSipUserTable_commit_row(void **my_data_context, int new_or_del)
{
    VOIPSIPUSERCFG_S      *datactx = *my_data_context;
    int                   i = 0;

    /* printf("**** ifxSipUserTable_commit_row ****\n"); */

    if (new_or_del == -1)
    {
        return SNMP_ERR_NOERROR; /* no change in the value */
    }

    for ( i = 0; i < IFX_CM_MAX_ENDPTS; i++)
    {
        if (i == datactx->ulEndPointIdx)
        {
            memset (&g_xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));

           	g_xCmMsg.ucMsgType = IFX_CM_SET_REQ;
        	g_xCmMsg.ucInfoType = IFX_CM_SIP_CFG_USER;
        	g_xCmMsg.ucChannel = i;
            strncpy (g_xCmMsg.uxData.xSipUserCfg.acUserName,
                     datactx->cUserName,
                     strlen(datactx->cUserName));
            strncpy (g_xCmMsg.uxData.xSipUserCfg.acDomain,
                     datactx->cDomainName,
                     strlen(datactx->cDomainName));
            strncpy (g_xCmMsg.uxData.xSipUserCfg.acDisplayName,
                     datactx->cDisplayName,
                     strlen(datactx->cDisplayName));
            strncpy (g_xCmMsg.uxData.xSipUserCfg.acAuthUserName,
                     datactx->cAuthName,
                     strlen(datactx->cAuthName));
            strncpy (g_xCmMsg.uxData.xSipUserCfg.acPasswd,
                     datactx->cAuthPasswd,
                     strlen(datactx->cAuthPasswd));
            g_xCmMsg.uxData.xSipUserCfg.ucRegStatus = datactx->ulRegStatus;

            if (IFX_CM_SendDataToCM (&g_xCmMsg) != IFX_CM_SUCCESS)
            {
                snmp_log(LOG_ERR, "ifxSipUserTable: Fail to send RM-Codec data to CM");
                return SNMP_ERR_COMMITFAILED;
            }
        }
    }

    /*
     * return no errors.  And there shouldn't be any!!!  Ever!!!  You
     * should have checked the values long before this. 
     */
    return SNMP_ERR_NOERROR;
}

/*
 * User-defined data access functions (per column) for data in table ifxSipUserTable 
 */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */
/** XXX: return a data pointer to the data for the suUserName column and set
         ret_len to its proper size in bytes. */
char           *
get_suUserName(void *data_context, size_t * ret_len)
{
    VOIPSIPUSERCFG_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->cUserName);
    return (char *)&datainfo->cUserName;
}

/** XXX: Set the value of the suUserName column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_suUserName(void *data_context, char *val, size_t val_len)
{
    VOIPSIPUSERCFG_S *datainfo = data_context;
    memset(&datainfo->cUserName, 0x00, sizeof(datainfo->cUserName));
    memcpy(&datainfo->cUserName, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the suDomainName column and set
         ret_len to its proper size in bytes. */
char           *
get_suDomainName(void *data_context, size_t * ret_len)
{
    VOIPSIPUSERCFG_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->cDomainName);
    return (char *)&datainfo->cDomainName;
}

/** XXX: Set the value of the suDomainName column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_suDomainName(void *data_context, char *val, size_t val_len)
{
    VOIPSIPUSERCFG_S *datainfo = data_context;
    memset(&datainfo->cDomainName, 0x00, sizeof(datainfo->cDomainName));
    memcpy(&datainfo->cDomainName, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the suDisplayName column and set
         ret_len to its proper size in bytes. */
char           *
get_suDisplayName(void *data_context, size_t * ret_len)
{
    VOIPSIPUSERCFG_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->cDisplayName);
    return (char *)&datainfo->cDisplayName;
}

/** XXX: Set the value of the suDisplayName column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_suDisplayName(void *data_context, char *val, size_t val_len)
{
    VOIPSIPUSERCFG_S *datainfo = data_context;
    memset(&datainfo->cDisplayName, 0x00, sizeof(datainfo->cDisplayName));
    memcpy(&datainfo->cDisplayName, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the suAuthName column and set
         ret_len to its proper size in bytes. */
char           *
get_suAuthName(void *data_context, size_t * ret_len)
{
    VOIPSIPUSERCFG_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->cAuthName);
    return (char *)&datainfo->cAuthName;
}

/** XXX: Set the value of the suAuthName column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_suAuthName(void *data_context, char *val, size_t val_len)
{
    VOIPSIPUSERCFG_S *datainfo = data_context;
    memset(&datainfo->cAuthName, 0x00, sizeof(datainfo->cAuthName));
    memcpy(&datainfo->cAuthName, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the suAuthPasswd column and set
         ret_len to its proper size in bytes. */
char           *
get_suAuthPasswd(void *data_context, size_t * ret_len)
{
    VOIPSIPUSERCFG_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->cAuthPasswd);
    return (char *)&datainfo->cAuthPasswd;
}

/** XXX: Set the value of the suAuthPasswd column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_suAuthPasswd(void *data_context, char *val, size_t val_len)
{
    VOIPSIPUSERCFG_S *datainfo = data_context;
    memset(&datainfo->cAuthPasswd, 0x00, sizeof(datainfo->cAuthPasswd));
    memcpy(&datainfo->cAuthPasswd, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the suRegStatus column and set
         ret_len to its proper size in bytes. */
u_long           *
get_suRegStatus(void *data_context, size_t * ret_len)
{
    VOIPSIPUSERCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulRegStatus);
    return &datainfo->ulRegStatus;
}

/** XXX: return a data pointer to the data for the suRowStatus column and set
         ret_len to its proper size in bytes. */
long           *
get_suRowStatus(void *data_context, size_t * ret_len)
{
    VOIPSIPUSERCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->lRowStatus);
    return &datainfo->lRowStatus;
}

/** XXX: Set the value of the suRowStatus column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_suRowStatus(void *data_context, long *val, size_t val_len)
{
    VOIPSIPUSERCFG_S *datainfo = data_context;
    datainfo->lRowStatus = ROWSTATUS_ACTIVE;
    memcpy(&datainfo->lRowStatus, val, val_len);
    return SNMP_ERR_NOERROR;
}
